Subject: Re: [Linux-fbdev-devel] [PATCH 1/2] fb: add support for foreign endianness

From: Benjamin Herrenschmidt <[email-masked]>
Date: Tue, 19 Feb 2008 11:35:53 +1100

On Tue, 2008-02-19 at 00:35 +0100, Clemens Koller wrote:
> [email-masked] schrieb:
> > On Mon, 18 Feb 2008 08:18:47 +0100, Krzysztof Helt said:
> >> I know two fb drivers which use endianess information (pm2fb and s3c2410fb).
> >> Both resolve endianess at driver level. Actually, both handle it by setting special
> >> bits so the graphics chip itself reorder bytes to transform foreign endianess. 
> >> I understand that this patch is for chips which cannot reorder bytes by themselves.
> > 
> > Does anybody know of such a chip that's actually available in the wild?  Or are
> > we writing drivers for speculative possible chips?
> > 
> 
> I had troubles with the Silicon Motion SM501/SM502 endianess on PowerPC PCI vs. LocalBus.
> The chip also has a register to swap endianess, but that seems to only affect some
> LocalBus modes.
> The current fb and X drivers are working, but when it comes to font
> aliasing and hw-acceleration, the problems start to rise again...

Most "sane" gfx chips nowadays provide configurable surfaces that allow
to perform the swap when writing/reading from regions of the
framebuffer, with the ability to set a different swapper setting (based
on bit depth) per region.

Then there is also the risk that your PCI<->Localbus has been wired
improperly :-)

Ben.